/*******************************************************************************

   SIMULADOR DE RODA FONICA 60-2

   VERSO 1

   COM PIC 12F675

   AUTOR: CLAUDIO LARIOS

   DATA: 18/07/2019

   ESTE ARQUIVO  PARTE INTEGRANTE DO BLOG 'LARIOS.TECNOLOGIA.WS'
   MATERIAL EXPERIMENTAL PARA FINS DIDTICO APENAS.

*******************************************************************************/

#include <12F675.h>//pic
#device adc=10
#use delay(clock=4000000)//oscilador interno de 4mhz
#fuses NOWDT,INTRC_IO, NOCPD, NOPROTECT, NOMCLR, NOPUT, NOBROWNOUT//configurao

//byte
#byte  gpio        = 0x05
#byte  trisio      = 0x85
#byte  timer0      = 0x01
#byte  cmcon       = 0x19
#byte  ansel       = 0x9f
//bits
#bit   sinal_roda        = 0x05.5  //pino 2 sada de pulsos similar a roda fonica

//variavis globais
unsigned int8 cont_d=0;// contador de n. dente
unsigned int16 adc_leitura;
/*==============================================================================
                     SUB-ROTINAS
==============================================================================*/



//------------------------------------------------------------------------------
//          ROTINA PRINCIPAL
//          INICIALIZAO DE PORTAS E VARIVEIS
//------------------------------------------------------------------------------

void main() {
   setup_adc(ADC_CLOCK_INTERNAL);
   setup_adc_ports(sAN2|VSS_VDD);//entrada analgicas para pot e sensor
   cmcon=7;//desliga comparador
   gpio= 0x00;//port em '0x00'
   trisio=0b011111;//in/out
   set_adc_channel(2);//mede entrada do potencimetro
   delay_us(10);

//------------------------------------------------------------------------------
//         LAO PRINCIPAL DE REPETIO
//------------------------------------------------------------------------------
   for(;;){
   

  
     adc_leitura = read_adc();//L o valor da tenso do cursor do potencimetro
     adc_leitura=adc_leitura/2;
     if(!adc_leitura)adc_leitura=1;//valor mnimo
     while(adc_leitura)adc_leitura--;
     cont_d++;
     if(cont_d<=116)sinal_roda=!sinal_roda;
     if(cont_d>=120)cont_d=0;

   }//for(;;)

}//main()










